/*
Marcin Owsiany 8:00
4 7.12.2000
10 18
*/

#include <unistd.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <sys/time.h>
#include <strings.h>
#include <string.h>
#include "msg.h"
#include "interface.h"

#define MAXDATA MAXMSG*100

char *modes[] = {"FIFO", "MSGQ", "SHMEM"};


long int rcvstats[3][6];
long int sndstats[3][6];
long int rcvustats[3][6];
long int sndustats[3][6];

/* 6 chunks
 * 3 modes
 */


int main(int argc, char **argv)
{
	int x, a, mode, *chunk, len = 2048, startlen = 2048, cnt, chldstat;
	struct my_msgbuf msg = { 1L, "" };
	char *foo;
	int chunks[] = {64, 128, 256, 512, 1024, 2048, 0};
	struct timeval tm1, tm2;
	
	if ((a = fork()) == -1) {
		perror("fork()");
	} else if (a == 0) {
		/*printf("Client pid %d\n", (int) getpid());*/
		if ((foo = malloc(len)) == NULL) {
			perror("malloc()");
			exit(EXIT_FAILURE);
		}
		for (mode = 1; mode <= 3; mode++) {
			x = client_init(mode);
			for (chunk = chunks; *chunk != 0; chunk++) {
				len = startlen;
				sndstats[mode][((int) chunks) - ((int) chunk)] = 0;
				sndustats[mode][((int) chunks) - ((int) chunk)] = 0;
				while (len) {
					strncpy(msg.mtext, foo, *chunk);
					/*printf("Client sending %d bytes using mode %d (%s) ...\n", *chunk + sizeof(long), mode, modes[mode - 1]);*/
					fflush(stdout);
					gettimeofday (&tm1, NULL);
					my_msgsnd(x, &msg, sizeof(long) + *chunk, mode);
					gettimeofday (&tm2, NULL);
					sndstats[mode][((int) chunks) - ((int) chunk)] += (tm2.tv_sec - tm1.tv_sec);
					sndustats[mode][((int) chunks) - ((int) chunk)] += (tm2.tv_usec - tm1.tv_usec);
					/*printf("...sent.\n");*/
					fflush(stdout);
					len -= *chunk;
				}
				fprintf(stdout, "SND - %ld\n", sndstats[mode][((int) chunks) - ((int) chunk)]*1000000 + sndustats[mode][((int) chunks) - ((int) chunk)]);
			}
		}
/*		printf("Client finished\n");*/
	} else {
		/*printf("Server pid %d\n", (int) getpid());*/
		for (mode = 1; mode <= 3; mode++) {
			/* bzero(msg.mtext, MAXMSG); */
			x = server_init(mode);
			for (chunk = chunks; *chunk != 0; chunk++) {
			/*	sleep(1);*/
			/*	x = server_init(mode, ((int) chunks) - ((int) chunk));*/
				len = startlen;
				rcvstats[mode][((int) chunks) - ((int) chunk)] = 0;
				rcvustats[mode][((int) chunks) - ((int) chunk)] = 0;
				while (len) {
					/*printf("Server receiving %d bytes using mode %d (%s)...\n", *chunk, mode, modes[mode - 1]);*/
					fflush(stdout);
					gettimeofday (&tm1, NULL);
					if ((cnt = my_msgrecv(x, &msg, sizeof(long) + *chunk, mode)) == -1) {
						perror("Receiving");
						exit(EXIT_FAILURE);
					}
					gettimeofday (&tm2, NULL);
					rcvstats[mode][((int) chunks) - ((int) chunk)] += (tm2.tv_sec - tm1.tv_sec);
					rcvustats[mode][((int) chunks) - ((int) chunk)] += (tm2.tv_usec - tm1.tv_usec);
					len -= *chunk;
					/*printf("...received %d bytes (%d left).\n", cnt, len);*/
					fflush(stdout);
				}
				fprintf(stdout, "RCV - %ld\n", rcvstats[mode][((int) chunks) - ((int) chunk)]*1000000 + rcvustats[mode][((int) chunks) - ((int) chunk)]);
			/*	my_close(x, mode);*/
			}
			if (my_close(x, mode) != 0) {
				perror("my_close");
				exit(EXIT_FAILURE);
			}
		}
/*		printf("Server finished\n");
 *		printf("Waiting for client to shut down\n");*/
		waitpid(a, &chldstat, 0);
		fprintf(stderr, "Child returned %d.\n", chldstat);
	}
	return 0;
}
